#!/bin/sh



RPMROOT=/var/tmp/fwbuilder
EXPORTDIR=`pwd`/export
SPECFILE=fwbuilder.spec


./configure

cp fwbuilder.spec fwbuilder.spec.save
make distclean
mv fwbuilder.spec.save fwbuilder.spec


# rm -f  config.log \
# 	config.cache \
# 	config.status \
# 	snapshot.tag \
# 	config.h \
# 	libtool \
# 	stamp-h 
# rm -rf export/fwbuilder*

if [ ! -f $SPECFILE ]; then
    echo "Can't find spec file"
    exit 1
fi

VERSION=`awk '/Version:/ { print $2; }' $SPECFILE`
TAR_FILE=fwbuilder-${VERSION}.tar.gz
SNAPSHOT_DIR=fwbuilder-${VERSION}


cd ${EXPORTDIR}
rm -rf ${SNAPSHOT_DIR}
ln -s .. ${SNAPSHOT_DIR}
find ${SNAPSHOT_DIR} -follow -name CVS -o -name export -o -name web -o -name exclude -o -name '*~' > exclude
tar -c -h --exclude-from exclude -f - ${SNAPSHOT_DIR} | gzip > ${TAR_FILE} 
cd ..


echo " === Building RPM for fwbuilder version $VERSION === "

mkdir -p ${RPMROOT}
mkdir -p ${RPMROOT}/SOURCES
mkdir -p ${RPMROOT}/BUILD
mkdir -p ${RPMROOT}/SPECS
mkdir -p ${RPMROOT}/SRCS
mkdir -p ${RPMROOT}/RPMS
mkdir -p ${RPMROOT}/RPMS/i386
mkdir -p ${RPMROOT}/SRPMS

if [ ! -d $EXPORTDIR ]; then
    echo "Can't find export directory"
    exit 1
else

    if [ ! -f ${EXPORTDIR}/${TAR_FILE} ]; then
	make tar
    fi

    cp ${EXPORTDIR}/${TAR_FILE} ${RPMROOT}/SOURCES
    cp ${SPECFILE} ${RPMROOT}/SPECS 
    cd ${RPMROOT}/SPECS
    rm -f .rpmmacros
    echo "%_topdir ${RPMROOT}" > .rpmmacros

    export HOME=`pwd`; rpm -ba ${SPECFILE} 

    cd ${RPMROOT}/RPMS/i386


    DISTRO="rh"`cat /etc/issue|grep release|sed 's/^[^0-9]*//;s/\.[0-9] .*$//'`
    RELEASE=`awk '/Release:/ {print $2;}' ${RPMROOT}/SPECS/$SPECFILE`

    for f in `ls *.rpm`; do
        nf=`echo $f | sed "s/$RELEASE.i386/$RELEASE-$DISTRO.i386/"`
        mv  $f  $nf
    done

fi

