/* 

                          Firewall Builder

                 Copyright (C) 2000 Vadim Kurland

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: ASDruidP10Dialog.cc,v 1.5 2001/04/08 06:47:03 vkurland Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/




#include "ASDruidP10Dialog.hh"

#include "Resources.hh"
#include <gdk_imlib.h>

ASDruidP10Dialog::ASDruidP10Dialog()
{
    string icn_path;
    string icn;
    GdkPixmap *pmap;
    GdkBitmap *mask;


    icn_path=
Resources::global_res->getResourceStr("/FWBuilderResources/Paths/Icndir");
    icn_path += "/";

    icn= icn_path+
Resources::global_res->getResourceStr("/FWBuilderResources/UI/Icons/ProtectHost");

    if ( gdk_imlib_load_file_to_pixmap(	(char*)(icn.c_str()), &pmap, &mask) ) {
	protect_host_pict->set(pmap,mask);
	gdk_imlib_free_pixmap(pmap);
    }


    icn= icn_path+
Resources::global_res->getResourceStr("/FWBuilderResources/UI/Icons/ProtectNet");

    if ( gdk_imlib_load_file_to_pixmap(	(char*)(icn.c_str()), &pmap, &mask) ) {
	two_interfaces_pict->set(pmap,mask);
	gdk_imlib_free_pixmap(pmap);
    }

    icn= icn_path+
Resources::global_res->getResourceStr("/FWBuilderResources/UI/Icons/ProtectNetAndDMZ");

    if ( gdk_imlib_load_file_to_pixmap(	(char*)(icn.c_str()), &pmap, &mask) ) {
	three_interfaces_pict->set(pmap,mask);
	gdk_imlib_free_pixmap(pmap);
    }

    ((Gtk::Label*)(protect_host->get_child()))->set_alignment(0.0,0.5);
    ((Gtk::Label*)(protect_one_net->get_child()))->set_alignment(0.0,0.5);
    ((Gtk::Label*)(protect_net_and_dmz->get_child()))->set_alignment(0.0,0.5);


}


