/* 

                          Firewall Builder

                 Copyright (C) 2000 Vadim Kurland

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: DialogPlugin.cc,v 1.6 2001/03/25 01:53:08 vkurland Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/



#include "glademm_support.hh"

#include "DialogPlugin.hh"
#include "BuiltinDialog.hh"
#include "helpers.hh"

#include "FWObjectDatabase.hh"
#include "ObjectTree.hh"

#include "MessageDialog.hh"

#include <ctype.h>

static gchar* err_1=" reimplement this virtual function!\n";


DialogPlugin::DialogPlugin() : Gtk::EventBox()
{
    dialog_buttons=true;
}

DialogPlugin::~DialogPlugin()
{
  //  cerr << "### DialogPlugin::~DialogPlugin()  \n";
}

/*
 *  The follwowing two functions are substitutions for 
 *  the corresponding methods from Gtk::Windows class
 *  So we could use glade to generate these dialogs
 */
void DialogPlugin::set_policy(gint allow_shrink, 
			      gint allow_grow, 
			      gint auto_shrink) {}

void DialogPlugin::set_title(const string& title) {}


void DialogPlugin::wrk2dlg()
{
  g_error("DialogPlugin::wrk2dlg() called: %s",err_1);
}

bool DialogPlugin::dlg2wrk()
{
  g_error("DialogPlugin::dlg2wrk() called: %s",err_1);
  return(false);
}


void DialogPlugin::data_changed_flag(bool val)
{
  /*
   *   find parent - object of the BuiltinDialog class and call
   *   its data_changed_flag function
   */
  BuiltinDialog *b = (BuiltinDialog*)find_widget("BuiltinDialog",this);
  if (b!=NULL)
    b->data_changed_flag(val);
}





Gtk::Menu* DialogPlugin::BuildCustomMenu()
{
    Gtk::MenuItem *mi;

    ObjectTree *ot=(ObjectTree*)find_widget("ObjectTree",this);
    g_assert(ot!=NULL);


    Gtk::Menu *obj_menu = new Gtk::Menu();
    obj_menu->set_name("obj_menu");

    mi=new Gtk::MenuItem("Copy");
    mi->set_name("copy");
    mi->activate.connect(SigC::slot(ot, &ObjectTree::on_copyobj));
    obj_menu->append(*mi);

    mi=new Gtk::MenuItem("Cut");
    mi->set_name("cut");
    mi->activate.connect(SigC::slot(ot, &ObjectTree::on_cutobj));
    obj_menu->append(*mi);

    mi=new Gtk::MenuItem("Paste");
    mi->set_name("paste");
    mi->activate.connect(SigC::slot(ot, &ObjectTree::on_pasteobj));
    obj_menu->append(*mi);
    

    return(obj_menu);
}

