/* 

                          Firewall Builder

                 Copyright (C) 2000 Vadim Kurland

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: DialogPlugin.hh,v 1.4 2001/03/25 01:53:08 vkurland Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#ifndef _DialogPlugin_HH
#  define _DialogPlugin_HH


#include <gtk--.h>

class FWObject;
class BuiltinDialog;

class DialogPlugin : public Gtk::EventBox
{

    friend class BuiltinDialog;

protected:

    FWObject  *object;
    bool       dialog_buttons;

    void data_changed_flag(bool val);

public:

    void set_policy(gint allow_shrink, gint allow_grow, gint auto_shrink);
    void set_title(const string& title);

    DialogPlugin();
    ~DialogPlugin();

    /*
     *  Implementations: virtual functions to be reimplemented in child classes
     */
    virtual void wrk2dlg();
    virtual bool dlg2wrk();
    virtual Gtk::Menu* BuildCustomMenu();

    /*
     *  standard error messages
     */
    static const char *IllegalName;

    FWObject* getObject() { return object; }

    bool needDialogButtons() { return dialog_buttons; }

};


#endif

