/* 

                          Firewall Builder

                 Copyright (C) 2000 Vadim Kurland

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: FWException.hh,v 1.5 2001/07/18 12:56:51 lord Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#ifndef _FW_EXCEPTION_HH
#define _FW_EXCEPTION_HH

#include <string>
#include <map>

/**
 * Base class for all Exceptions used in FWBuilder project
 */
class FWException
{
    private:
    
    protected:
    string reason;
    map<string, string> properties;
    
    public:

    /**
     * Creates exception with given reason
     */
    FWException(const string &reason);
    virtual ~FWException() {};

    /**
     * Returns textual representation of this exception
     */
    virtual const string &toString();

    map<string, string>& getProperties();
    
};

class FWNotSupportedException: public FWException
{
    public:

    FWNotSupportedException(const string &reason):FWException(reason) {};
};

#endif

