/* 

                          Firewall Builder

                 Copyright (C) 2000 Vadim Kurland

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: FirewallDialog.hh,v 1.17 2001/07/23 05:25:25 vkurland Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/



#ifndef _FIREWALLDIALOG_HH
#  include "FirewallDialog_glade.hh"
#  define _FIREWALLDIALOG_HH
#include "glademm_support.hh"

/*
 *  workaround for the bug in glademm
 */
#define GTK_FILLX GTK_FILL_X
#define GTK_FILLY GTK_FILL_Y

#include "sigc++/slot.h"
#include "FWObject.hh"

class Interface;
class PolicyList;
class FirewallOptions;
class IPAddressWidget;

class FirewallDialog : public FirewallDialog_glade
{   
        
    friend class FirewallDialog_glade;

    void on_ipfilter_log_level_changed();
    void on_iptables_log_level_changed();
    void on_iptables_limit_suffix_changed();
    void on_iptables_action_on_reject_changed();
    void on_fw_platform_changed();

    void on_changed();

    void on_new_if_clicked();
    void on_del_if_clicked();
    void on_snmp_get_clicked();
    void on_snmp_get_released();
    void on_edit_clicked();
    void on_find_compiler_clicked();
    void on_find_install_script_clicked();
    void on_snmp_get_descr_released();
    void on_dyn_addr_toggled();
    void on_switch_page(Gtk::Notebook_Helpers::Page* p0,guint p1);
    void on_dns_lookup();

    void on_if_list_select_row(gint row, gint column, GdkEvent *event);
    void on_add_rule_clicked();
    void on_del_rule_clicked();

    void showInterfaces();
    void showInterfacePolicy(Interface *intf);
    Interface* getSelectedInterface();
    Interface* getInterfaceByRow(int row);

    FirewallOptions *options;
    PolicyList      *interface_policy_list;

    vector<string>  log_levels;
    vector<string>  limit_suffixes;
    vector<string>  actions_on_reject;
    vector<string>  platforms;

    IPAddressWidget*   fw_addr;


public:

    FirewallDialog(FWObject *obj);
    ~FirewallDialog();

    void if2dlg();

    virtual void wrk2dlg();
    virtual bool dlg2wrk();

    PolicyList* getPolicyList() { return interface_policy_list; }

};
#endif
