/* 

                          Firewall Builder

                 Copyright (C) 2000 Vadim Kurland

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: Host.cc,v 1.7 2001/05/26 01:16:15 lord Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

/*
 * $Id: Host.cc,v 1.7 2001/05/26 01:16:15 lord Exp $
 */

#include "FWObject.hh"
#include "Interface.hh"

#include "Host.hh"
#include "HostDialog.hh"

#include "XMLTools.hh"

const char *Host::TYPENAME={"Host"};

Host::Host()  
{
    setStr("address", "");
}

Host::~Host() 
{
  clearChildren();
}

void Host::fromXML(xmlNodePtr root)
{
    const char *n=FROMXMLCAST(xmlGetProp(root,TOXMLCAST("address")));
    assert(n!=NULL);
    setStr("address", n);

    n=FROMXMLCAST(xmlGetProp(root,TOXMLCAST("snmp_read_community")));
    if (n!=NULL) setStr("snmp_read_community", n);

    n=FROMXMLCAST(xmlGetProp(root,TOXMLCAST("snmp_write_community")));
    if (n!=NULL) setStr("snmp_write_community", n);

    FWObject::fromXML(root);
}

DialogPlugin* Host::CreateDialog()
{
  return( new HostDialog(this) );
}

bool  Host::validateChild(FWObject *o)
{ 
    string otype=o->getTypeName();
    return (FWObject::validateChild(o) && otype=="Interface");
}


/*
 *  TODO:    Implement syntax checks for interfaces
 *
 */
bool Host::Appropriate(Interface *i)
{
  return true;
}

void Host::addInterface(Interface *i)
{
    add(i);
}

void Host::removeInterface(Interface *i)
{
    remove(i);
}






