/* 

                          Firewall Builder

                 Copyright (C) 2000 Vadim Kurland

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: Interface.hh,v 1.10 2001/07/13 16:24:39 lord Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef _INTERFACE_H_
#define _INTERFACE_H_

#include <string>
#include "FWObject.hh"
#include "FWException.hh"
#include "IPAddress.hh"
#include <gtk--.h>

class Interface : public FWObject 
{
    private:
    
    // This attribute currently not saved in XML
    string physical_address;

    public:
    
    Interface();
    Interface(Interface *i);
    Interface(const Interface &i);
    Interface(const string& n,const string& a,const string& n,
	      bool ext=false, bool dyn=false, string physical_address="");
    Interface(const string& n,const string& a,const string& n,
	      const string& ext,const string& dyn, string physical_address="");

    IPNetwork getIPNetwork() const throw(FWException);
    
    virtual void fromXML(xmlNodePtr parent);

    virtual bool  validateChild(FWObject *o);

    DECLARE_FWOBJECT_SUBTYPE(Interface);

    bool isExt();
    bool isDyn();

    const string &getPhysicalAddress() const { return physical_address; }
    const IPAddress getIPAddess() const throw(FWException);

};
#endif


