/* 

                          Firewall Builder

                 Copyright (C) 2000 Vadim Kurland

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: ListOfIcons.hh,v 1.7 2001/07/07 08:35:50 vkurland Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/




#ifndef _LIST_OF_ICONS_HH
#define _LIST_OF_ICONS_HH

#include <gtk--.h>
#include <gnome-wrappers/iconlist.hh>

#include "FWObject.hh"


class ListOfIcons : public IconList {

    gint    current_selected;
    gint    count;
    bool    popup;

    gint on_button_press_event(GdkEventButton *ev);
    gint on_button_release_event(GdkEventButton *ev);
    gint on_key_press_event(GdkEventKey *ev);

    
    void set_data_changed_flag(bool flag);
    void move_focus(GtkDirectionType dir);
  
public:

    ListOfIcons(gint icon_with,bool allow_popup_menu);
    ~ListOfIcons();

    void    clear();

    void    addObject(FWObject *obj);
    void    removeObject(int no);

    string  getObjectId(int no);

    bool    checkObjectId(const string& id);

    gint    getCount();
	  
    void    enableMenu()  { popup=true;  }
    void    disableMenu() { popup=false; }

    SigC::Signal1<void,void*>open_item;
    SigC::Signal1<void,void*>popup_menu;
};


#endif
