/* 

                          Firewall Builder

                 Copyright (C) 2001 Vadim Kurland

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: MiniBrowserDialog.cc,v 1.3 2001/06/23 18:32:48 vkurland Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#include "config.h"

#include "gnome-wrappers/htmlviewer.hh"
#include "MiniBrowserDialog.hh"

#include <iostream>
#include <fstream>

MiniBrowserDialog::MiniBrowserDialog() : MiniBrowserDialog_glade()
{
    html_v = manage(new HTMLViewer() );
    html_v->show();
    html_viewport->add( *html_v );

    close_button->set_flags(GTK_CAN_FOCUS|GTK_CAN_DEFAULT);
    close_button->grab_default();
    close_button->grab_focus();
}

void MiniBrowserDialog::on_close_clicked()
{
    hide();
}

void MiniBrowserDialog::loadHTML(const char* src)
{
    html_v->set_html_source( src );
}

void MiniBrowserDialog::loadFromFile(const string& filename)
{
    string rn,s;

//    cerr << "Showing " << filename << endl;

    std::ifstream in(filename.c_str());

    while (in) {
	in >> s;
	rn=rn+s+" ";
    }

    html_v->set_html_source( rn.c_str() );
}


