/* 

                          Firewall Builder

                 Copyright (C) 2000 Vadim Kurland

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: NAT.cc,v 1.8 2001/03/19 20:46:07 vkurland Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/



#include "NAT.hh"
#include "NATDialog.hh"
#include "Rule.hh"

#include "FWOptions.hh"

#include "FWObjectDatabase.hh"
#include "helpers.hh"

const char *NAT::TYPENAME={"NAT"};

static const char *rels[]={
    "OSrc",
    "ODst",
    "OSrv",
    "TSrc",
    "TDst",
    "TSrv",
    "Com",
    NULL
};
 
NAT::NAT() : RuleSet() 
{
    remStr("name");
    remStr("comment");

    rule_elements=rels;
}


NAT::~NAT()  {}

Rule* NAT::createRule()
{
    Rule      *r;

    r= new NATRule();
    r->add( new NATRuleOptions() );

    return r;
}

DialogPlugin* NAT::CreateDialog()
{
  return( new NATDialog(this) );
}








