/* 

                          Firewall Builder

                 Copyright (C) 2001 Vadim Kurland

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: ObjectDescriptor.hh,v 1.4 2001/07/24 07:45:33 vkurland Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#ifndef OBJECTDESCRIPTOR_HH
#define OBJECTDESCRIPTOR_HH

#include "Interface.hh"
#include "IPAddress.hh"

#include "dns.hh"
#include "snmp.hh"

#include <vector>
#include <string>

class ObjectDescriptor {

    public:
    
    ObjectDescriptor() {}

#ifdef HAVE_LIBSNMP
    ObjectDescriptor(CrawlerFind cf) {
	have_snmpd       = cf.have_snmpd;
	descr            = cf.descr;
	contact          = cf.contact;
	location         = cf.location;
	sysname          = cf.sysname;
	interfaces       = cf.interfaces;
	MAC_addr         = cf.found_phys_addr;
	dns_info.name    = cf.dns_info.name;
	dns_info.aliases = cf.dns_info.aliases;
    }
#endif

    virtual ~ObjectDescriptor()   {};

    bool have_snmpd ;
    string  descr, contact, location, sysname;
    vector<Interface> interfaces ;

    string            MAC_addr;

    HostEnt           dns_info;

    IPAddress         addr;
};

#endif
