/* 

                          Firewall Builder

                 Copyright (C) 2000 Vadim Kurland

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: ObjectTree.hh,v 1.11 2001/06/29 08:40:13 vkurland Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#ifndef _ObjectTree_HH
#  define _ObjectTree_HH

#include <gtk--.h>

#include "FWObject.hh"
#include "helpers.hh"

class main_window;





class ObjectTree : public Gtk::CTree
{   

    friend class main_window;

/* ignore showInTree flag */
    bool show_all;
    bool rebuild_scheduled;

// all these store ID
    string           selected_object;    
    string           last_clicked_object;
    string           drag_object;
    string           show_object;

    gint on_button_press_event(GdkEventButton *ev);
    gint on_button_release_event(GdkEventButton *ev);

    void source_drag_begin( GdkDragContext     *context);
    void source_drag_data_get  ( GdkDragContext     *context,
				 GtkSelectionData   *selection_data,
				 guint               info,
				 guint32             time );
    void source_drag_data_delete ( GdkDragContext     *context );

    gint on_key_press_event(GdkEventKey *ev);
    void selection_made(gint       row,
			gint       column,
			GdkEvent  *ev);

    gint rebuild_when_idle();
    gint rebuild_and_show_when_idle();

    void displaySubtree(Gtk::CTree_Helpers::RowList::iterator &j, FWObject *o);
    
public:

    ObjectTree();

    string get_current_selection();

    void selectRow(gint row_n);
    void selectObject(string id);

    void TreePopupMenu();

    void ShowObject(string &id);
    void clearSelection();

    void rebuildTree();
    void rebuildTreeAndShow(string &id);

/*  menu callbacks (menu gets created in DialogPlugin or derivatives) */
    void  on_new_fw();
    void  on_new_host();
    void  on_new_net();
    void  on_new_obj_group();
    void  on_new_ip();
    void  on_new_icmp();
    void  on_new_tcp();
    void  on_new_udp();
    void  on_new_srv_group();
    void  on_new_time();


    FWObject*  newObject(const string& where_id , const string& type);
    FWObject*  newObject(const string& where_id , FWObject *obj);

    void  on_duplicate();
    void  on_copyobj();
    void  on_cutobj();
    void  on_pasteobj();
    void  on_sort();

    void pasteTo(FWObject *target, FWObject *obj);

    void schedule_rebuild();
    void schedule_rebuild_and_show(string id);

};

#endif
