/* 

                          Firewall Builder

                 Copyright (C) 2000 Vadim Kurland

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: OptionsDlg.cc,v 1.15 2001/07/22 06:13:19 vkurland Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#include <gtk--/main.h>

#include "OptionsDlg.hh"

#include "main_window.hh"
#include "helpers.hh"
#include "MessageDialog.hh"



OptionsDlg::OptionsDlg()
{
    commit_changes=false;

    button10->set_flags(GTK_CAN_FOCUS|GTK_CAN_DEFAULT);
    button12->set_flags(GTK_CAN_FOCUS|GTK_CAN_DEFAULT);
    button12->grab_default();
    button12->grab_focus();

/*
 *  Paths  tab
 */
/*
  icn_dir->set_text(  
      Preferences::global_prefs->getOpt("/FWBuilderPreferences/Paths/Icndir") );
*/
/*
  snmpget_path->set_text(  
      Preferences::global_prefs->getOpt("/FWBuilderPreferences/Paths/SNMPget") );
  snmpwalk_path->set_text( 
      Preferences::global_prefs->getOpt("/FWBuilderPreferences/Paths/SNMPwalk") );
*/

  wdir->set_text(
      Preferences::global_prefs->getOpt("/FWBuilderPreferences/Paths/Wdir") );
      
  wdir->grab_focus();

/*
 *   User Interface  tab
 */

  ((Gtk::Label*)(icons_in_policy->get_child()))->set_alignment(0.0,0.5);
  ((Gtk::Label*)(large_icons_in_group->get_child()))->set_alignment(0.0,0.5);
 
  icons_in_policy->set_active( 
      Preferences::global_prefs->getOptBool(
	  "/FWBuilderPreferences/UI/ShowIconsInPolicy") );

  large_icons_in_group->set_active(
      Preferences::global_prefs->getOptBool(
	  "/FWBuilderPreferences/UI/LargeIconsInGroups") );



  ((Gtk::Label*)(quick_view_off->get_child()))->set_alignment(0.0,0.5);
  ((Gtk::Label*)(quick_view_popup->get_child()))->set_alignment(0.0,0.5);
  ((Gtk::Label*)(quick_view_window->get_child()))->set_alignment(0.0,0.5);

  string qv=Preferences::global_prefs->getOptStr(
      "/FWBuilderPreferences/UI/ObjectQuickView");

  if ( qv=="off" )     quick_view_off->set_active(true);
  if ( qv=="popup" )   quick_view_popup->set_active(true);
  if ( qv=="window" )  quick_view_window->set_active(true);

  quick_view_timeout->set_value(
      Preferences::global_prefs->getOptInt(
	  "/FWBuilderPreferences/UI/ObjectQuickViewTimeout") );

  ((Gtk::Label*)(autosave->get_child()))->set_alignment(0.0,0.5);

  autosave->set_active(
      Preferences::global_prefs->getOptBool("/FWBuilderPreferences/UI/Autosave")  );



  snmp_timeout->set_value(
      Preferences::global_prefs->getOptInt(
	  "/FWBuilderPreferences/Network/SNMPTimeout") );

  snmp_retries->set_value(
      Preferences::global_prefs->getOptInt(
	  "/FWBuilderPreferences/Network/SNMPRetries") );

  dns_timeout->set_value(
      Preferences::global_prefs->getOptInt(
	  "/FWBuilderPreferences/Network/DNSTimeout") );

  dns_retries->set_value(
      Preferences::global_prefs->getOptInt(
	  "/FWBuilderPreferences/Network/DNSRetries") );



//  show_hidden->set_active(
//      Preferences::global_prefs->getOpt("/FWBuilderPreferences/UI/ShowHidden")=="1");


}

OptionsDlg::~OptionsDlg() {}

void OptionsDlg::run()
{
    commit_changes=false;

    Gtk::Main::grab_add(*this);
    Gtk::Main::run();
    Gtk::Main::grab_remove(*this);

    if (commit_changes) {


/*
 *  Paths  tab
 */
/*
	Preferences::global_prefs->setOpt("/FWBuilderPreferences/Paths/Icndir",
			     icn_dir->get_text().c_str());

	Preferences::global_prefs->setOpt(
	    "/FWBuilderPreferences/Paths/SNMPget",
	    snmpget_path->get_text().c_str());

	Preferences::global_prefs->setOpt(
	    "/FWBuilderPreferences/Paths/SNMPwalk",
	    snmpwalk_path->get_text().c_str() );
*/
	Preferences::global_prefs->setOpt(
	    "/FWBuilderPreferences/Paths/Wdir",
	    wdir->get_text().c_str() );

/*
 *   User Interface  tab
 */
	Preferences::global_prefs->setOptBool(
	    "/FWBuilderPreferences/UI/ShowIconsInPolicy",
	    icons_in_policy->get_active() );

	Preferences::global_prefs->setOptBool(
	    "/FWBuilderPreferences/UI/LargeIconsInGroups",
	    large_icons_in_group->get_active() );


	string qv;

	if (quick_view_off->get_active())    qv="off";
	if (quick_view_popup->get_active())  qv="popup";
	if (quick_view_window->get_active()) qv="window";

	Preferences::global_prefs->setOpt("/FWBuilderPreferences/UI/ObjectQuickView", qv.c_str() );

	Preferences::global_prefs->setOptInt(
	    "/FWBuilderPreferences/UI/ObjectQuickViewTimeout",
	    quick_view_timeout->get_value_as_int() );

	Preferences::global_prefs->setOptBool(
	    "/FWBuilderPreferences/UI/Autosave",
	    autosave->get_active() );


/* Network */

	Preferences::global_prefs->setOptInt(
	    "/FWBuilderPreferences/Network/SNMPTimeout",
	    snmp_timeout->get_value_as_int() );

	Preferences::global_prefs->setOptInt(
	    "/FWBuilderPreferences/Network/SNMPRetries",
	    snmp_retries->get_value_as_int() );

	Preferences::global_prefs->setOptInt(
	    "/FWBuilderPreferences/Network/DNSTimeout",
	    dns_timeout->get_value_as_int() );

	Preferences::global_prefs->setOptInt(
	    "/FWBuilderPreferences/Network/DNSRetries",
	    dns_retries->get_value_as_int() );


//	Preferences::global_prefs->setOpt("/FWBuilderPreferences/UI/ShowHidden",
//			     show_hidden->get_active()?"1":"0");

        try
        {
            Preferences::global_prefs->savePrefs();
        } catch(FWException &ex)
        {
	    MessageDialog::Error("Error saving preferences.",ex.toString());
        }

	main_w->RefreshRightPane();
  }
}

void OptionsDlg::on_ok_clicked()
{   
    commit_changes=true;
    Gtk::Main::quit();
}

void OptionsDlg::on_cancel_clicked()
{   
    commit_changes=false;
    Gtk::Main::quit();
}








