/* 

                          Firewall Builder

                 Copyright (C) 2000 Vadim Kurland

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: Policy.cc,v 1.14 2001/04/01 08:15:34 vkurland Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#include "FWObjectDatabase.hh"

#include "Policy.hh"
#include "PolicyDialog.hh"
#include "Rule.hh"
#include "helpers.hh"

#include "FWOptions.hh"

#include "XMLTools.hh"
 
const char *Policy::TYPENAME={"Policy"};

static const char*  rels[]={
    "Src",
    "Dst",
    "Srv",
    "Act",
    "Log",
    "When",
    "Opt",
    "Com",
    NULL
};

Policy::Policy()
{
    remStr("name");
    remStr("comment");

    rule_elements=rels;
}

Policy::~Policy() {}

Rule*   Policy::createRule()
{
    Rule      *r;

    r= new PolicyRule();
    r->add( new PolicyRuleOptions() );

    return r;
}

DialogPlugin* Policy::CreateDialog()
{
  return( new PolicyDialog(this) );
}












