/* 

                          Firewall Builder

                 Copyright (C) 2000 Vadim Kurland

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: PolicyDialog.cc,v 1.8 2001/05/18 09:08:14 vkurland Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#include "FWObjectDatabase.hh"
#include "PolicyDialog.hh"
#include "helpers.hh"

#include "Firewall.hh"
#include "Policy.hh"
#include "PolicyList.hh"
#include "main_window.hh"



PolicyDialog::PolicyDialog(FWObject *obj)
{
    RuleSet  *pol;
    
    object=obj;
    dialog_buttons=true;

    policylist_ptr=NULL;

    assert( RuleSet::cast(obj)!=NULL );

    pol=RuleSet::cast(obj);

    policylist_ptr = manage(new PolicyList(pol));

  /*******************************************************************/

    /*  When user presses Enter while one of the policy items is selected,
     *  or chooses "Edit" pop-up menu item ,
     *    PolicyList sends signal open_item. 
     */

    policylist_ptr->open_item.connect(SigC::slot(this,&PolicyDialog::on_open_item));

    remove();

    Gtk::ScrolledWindow *sw=new Gtk::ScrolledWindow();
    sw->set_policy(GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

    add(*sw);
    sw->show();
    
    sw->add_with_viewport(*policylist_ptr);
    policylist_ptr->show();

    set_name("policy_dialog");
     
}

PolicyDialog::~PolicyDialog()
{
//  if (policylist_ptr!=NULL)  delete policylist_ptr;
//  policylist_ptr=NULL;
}

void PolicyDialog::on_open_item(void *arg)
{
    FWObject *obj=(FWObject*)arg;
    if (obj!=NULL) main_w->schedule_open_object(obj->getId());
}


void PolicyDialog::on_policy_line_add()
{
  data_changed_flag(true);
}

void PolicyDialog::on_policy_line_remove()
{
  data_changed_flag(true);
}

void PolicyDialog::wrk2dlg()
{
    if (policylist_ptr!=NULL)  policylist_ptr->Build();
}

bool PolicyDialog::dlg2wrk()
{
    return(true);
}


Gtk::Menu* PolicyDialog::BuildCustomMenu()
{
  Gtk::Menu *policy_menu = new Gtk::Menu();
/*
  Gtk::MenuItem *insert_top=new Gtk::MenuItem("Insert rule at the top");
  Gtk::MenuItem *append_bottom=new Gtk::MenuItem("Append rule at the bottom");
  Gtk::MenuItem *add_rule=new Gtk::MenuItem("Add rule after current");
  Gtk::MenuItem *remove_rule=new Gtk::MenuItem("Remove current rule");
  Gtk::MenuItem *move_up=new Gtk::MenuItem("Move current rule up");
  Gtk::MenuItem *move_down=new Gtk::MenuItem("Move current rule down");

  insert_top->set_name("insert_top");
  insert_top->activate.connect(SigC::slot((PolicyDialog*)this, 
  			  &PolicyDialog::on_insert_top));
  append_bottom->set_name("append_bottom");
  append_bottom->activate.connect(SigC::slot((PolicyDialog*)this, 
  			  &PolicyDialog::on_append_bottom));
  add_rule->set_name("add_rule");
  add_rule->activate.connect(SigC::slot((PolicyDialog*)this, 
  			  &PolicyDialog::on_add_rule));

  remove_rule->set_name("remove_rule");
  remove_rule->activate.connect(SigC::slot((PolicyDialog*)this, 
  			  &PolicyDialog::on_remove_rule));

  move_up->set_name("move_up");
  move_up->activate.connect(SigC::slot((PolicyDialog*)this, 
  			  &PolicyDialog::on_move_up));

  move_down->set_name("move_down");
  move_down->activate.connect(SigC::slot((PolicyDialog*)this, 
			  &PolicyDialog::on_move_down));

  policy_menu->set_name("policy_menu");
  policy_menu->append(*insert_top);
  policy_menu->append(*append_bottom);
  policy_menu->append(*add_rule);
  policy_menu->append(*remove_rule);
  policy_menu->append(*move_up);
  policy_menu->append(*move_down);
*/
  return(policy_menu);
}

