/* 

                          Firewall Builder

                 Copyright (C) 2000 Vadim Kurland

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: RuleElement.hh,v 1.10 2001/03/25 01:53:08 vkurland Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#ifndef _RULEELEMENT_HH_
#define _RULEELEMENT_HH_

#include "Group.hh"

#include "ObjectGroup.hh"
#include "ServiceGroup.hh"
#include "IntervalGroup.hh"

class Rule; 
class FWReference;

class RuleElement : virtual public FWObject {

protected:

public:
    RuleElement();
    DECLARE_FWOBJECT_SUBTYPE(RuleElement);

    virtual void fromXML(xmlNodePtr parent);

    void      setAnyElement();
    virtual   string  getAnyElementId();
    bool      isAny();

    bool   getNeg();
    void   setNeg(bool flag);
    void   toggleNeg();

};

class RuleElementSrc : public ObjectGroup, public RuleElement {
    public:
    DECLARE_FWOBJECT_SUBTYPE(RuleElementSrc);
    RuleElementSrc();
    virtual   string  getAnyElementId();
    virtual FWReference* createRef( FWObject* obj );
};

class RuleElementDst : public ObjectGroup, public RuleElement {
    public:
    DECLARE_FWOBJECT_SUBTYPE(RuleElementDst);
    RuleElementDst();
    virtual   string  getAnyElementId();
    virtual FWReference* createRef( FWObject* obj );
};

class RuleElementSrv : public ServiceGroup, public RuleElement {
    public:
    DECLARE_FWOBJECT_SUBTYPE(RuleElementSrv);
    RuleElementSrv();
    virtual   string  getAnyElementId();
    virtual FWReference* createRef( FWObject* obj );
};

class RuleElementInterval : public IntervalGroup, public RuleElement {
    public:
    DECLARE_FWOBJECT_SUBTYPE(RuleElementInterval);
    RuleElementInterval();
    virtual   string  getAnyElementId();
    virtual FWReference* createRef( FWObject* obj );
};

class RuleElementOSrc : public ObjectGroup, public RuleElement {
    public:
    DECLARE_FWOBJECT_SUBTYPE(RuleElementOSrc);
    RuleElementOSrc();
    virtual   string  getAnyElementId();
    virtual FWReference* createRef( FWObject* obj );
};

class RuleElementODst : public ObjectGroup, public RuleElement {
    public:
    DECLARE_FWOBJECT_SUBTYPE(RuleElementODst);
    RuleElementODst();
    virtual   string  getAnyElementId();
    virtual FWReference* createRef( FWObject* obj );
};

class RuleElementOSrv : public ServiceGroup, public RuleElement {
    public:
    DECLARE_FWOBJECT_SUBTYPE(RuleElementOSrv);
    RuleElementOSrv();
    virtual   string  getAnyElementId();
    virtual FWReference* createRef( FWObject* obj );
};

class RuleElementTSrc : public ObjectGroup, public RuleElement {
    public:
    DECLARE_FWOBJECT_SUBTYPE(RuleElementTSrc);
    RuleElementTSrc();
    virtual   string  getAnyElementId();
    virtual FWReference* createRef( FWObject* obj );
};

class RuleElementTDst : public ObjectGroup, public RuleElement {
    public:
    DECLARE_FWOBJECT_SUBTYPE(RuleElementTDst);
    RuleElementTDst();
    virtual   string  getAnyElementId();
    virtual FWReference* createRef( FWObject* obj );
};

class RuleElementTSrv : public ServiceGroup, public RuleElement {
    public:
    DECLARE_FWOBJECT_SUBTYPE(RuleElementTSrv);
    RuleElementTSrv();
    virtual   string  getAnyElementId();
    virtual FWReference* createRef( FWObject* obj );
};


#endif




