/* 

                          Firewall Builder

                 Copyright (C) 2000 Vadim Kurland

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: UDPService.cc,v 1.2 2001/03/31 07:43:13 vkurland Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#include "UDPService.hh"
#include "UDPServiceDialog.hh"
#include "XMLTools.hh"
#include "Preferences.hh"

const char *UDPService::TYPENAME={"UDPService"};


UDPService::UDPService()  
{
}

UDPService::~UDPService() {}

void UDPService::fromXML(xmlNodePtr root)
{
    FWObject::fromXML(root);

    const char *n;

    n=FROMXMLCAST(xmlGetProp(root,TOXMLCAST("src_range_start")));
    if(n!=NULL) setStr("src_range_start", n);

    n=FROMXMLCAST(xmlGetProp(root,TOXMLCAST("src_range_end")));
    if(n!=NULL) setStr("src_range_end", n);

    n=FROMXMLCAST(xmlGetProp(root,TOXMLCAST("dst_range_start")));
    if(n!=NULL) setStr("dst_range_start", n);

    n=FROMXMLCAST(xmlGetProp(root,TOXMLCAST("dst_range_end")));
    if(n!=NULL) setStr("dst_range_end", n);

}


DialogPlugin* UDPService::CreateDialog()
{
  return( new UDPServiceDialog(this) );
}








