
#include "druid.hh"


#include <gtk--.h>
#include <gnome.h>


class DruidVBox : public Gtk::VBox  {
    public:
    DruidVBox(GtkVBox *gtkobj) : Gtk::VBox(gtkobj) {}
};

static void on_druidpage_prepare(GnomeDruidPage  *gnomedruidpage,
				 gpointer         arg1,
				 gpointer         user_data)
{
    Druid *d=(Druid*)user_data;
    d->on_prepare(gnomedruidpage);
}

static gboolean on_druidpage_next(GnomeDruidPage  *gnomedruidpage,
				  gpointer         arg1,
				  gpointer         user_data)
{
    Druid *d=(Druid*)user_data;
    return d->on_next(gnomedruidpage);
}

static gboolean on_druidpage_back(GnomeDruidPage  *gnomedruidpage,
				  gpointer         arg1,
				  gpointer         user_data)
{
    Druid *d=(Druid*)user_data;
    return d->on_back(gnomedruidpage);
}


static gboolean on_druidpage_cancel(GnomeDruidPage  *gnomedruidpage,
				    gpointer         arg1,
				    gpointer         user_data)
{
    Druid *d=(Druid*)user_data;
    return d->on_cancel(gnomedruidpage);
}


static void on_druidpage_finish(GnomeDruidPage  *gnomedruidpage,
				gpointer         arg1,
				gpointer         user_data)
{
    Druid *d=(Druid*)user_data;
    d->on_finish(gnomedruidpage);
}




Druid::Druid(const string& t, const string& l) : 
    Gtk::Window(GTK_WINDOW_TOPLEVEL)
{


    title=t;
    logo=l;

    druidpagestart1_bg_color.pixel=0;
    druidpagestart1_bg_color.red=6425;
    druidpagestart1_bg_color.green=6425;
    druidpagestart1_bg_color.blue=28784;

    druidpagestart1_textbox_color.pixel=0;
    druidpagestart1_textbox_color.red= 65535;
    druidpagestart1_textbox_color.green= 65535;
    druidpagestart1_textbox_color.blue= 65535;

    druidpagestart1_logo_bg_color.pixel= 0;
    druidpagestart1_logo_bg_color.red= 65535;
    druidpagestart1_logo_bg_color.green= 65535;
    druidpagestart1_logo_bg_color.blue= 65535;


    druidpagestart1_title_color.pixel= 0;
    druidpagestart1_title_color.red= 65535;
    druidpagestart1_title_color.green= 65535;
    druidpagestart1_title_color.blue= 65535;

    
    druidpagestandard1_bg_color .pixel= 0;
    druidpagestandard1_bg_color.red= 6425;
    druidpagestandard1_bg_color.green= 6425;
    druidpagestandard1_bg_color.blue= 28784;

    
    druidpagestandard1_logo_bg_color .pixel= 0;
    druidpagestandard1_logo_bg_color.red= 65535;
    druidpagestandard1_logo_bg_color.green= 65535;
    druidpagestandard1_logo_bg_color.blue= 65535;


    druidpagestandard1_title_color .pixel= 0;
    druidpagestandard1_title_color.red= 65535;
    druidpagestandard1_title_color.green= 65535;
    druidpagestandard1_title_color.blue= 65535;

    
    druidpagefinish1_bg_color .pixel= 0;
    druidpagefinish1_bg_color.red= 6425;
    druidpagefinish1_bg_color.green= 6425;
    druidpagefinish1_bg_color.blue= 28784;


    druidpagefinish1_textbox_color .pixel= 0;
    druidpagefinish1_textbox_color.red= 65535;
    druidpagefinish1_textbox_color.green= 65535;
    druidpagefinish1_textbox_color.blue= 65535;


    druidpagefinish1_logo_bg_color .pixel= 0;
    druidpagefinish1_logo_bg_color.red= 65535;
    druidpagefinish1_logo_bg_color.green= 65535;
    druidpagefinish1_logo_bg_color.blue= 65535;


    druidpagefinish1_title_color .pixel= 0;
    druidpagefinish1_title_color.red= 65535;
    druidpagefinish1_title_color.green= 65535;
    druidpagefinish1_title_color.blue= 65535;



    set_name("druid_window");
    set_title(title);

    window1=(GtkWindow*)(gtkobj());

    druid1 = gnome_druid_new ();
    gtk_widget_ref (druid1);
    gtk_object_set_data_full (GTK_OBJECT (window1), "druid1", druid1,
                            (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (druid1);
    gtk_container_add (GTK_CONTAINER (window1), druid1);

}

void Druid::createStartPage(int page_id,const char* text)
{
    GtkWidget *druidpagestart1;


    druidpagestart1 = gnome_druid_page_start_new ();

    page_map[GNOME_DRUID_PAGE(druidpagestart1)]=page_id;

    gtk_widget_ref (druidpagestart1);
    gtk_object_set_data_full (GTK_OBJECT (window1), 
			      "druidpagestart1", 
			      druidpagestart1,
			      (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (druidpagestart1);
    gnome_druid_append_page (GNOME_DRUID (druid1), 
			     GNOME_DRUID_PAGE (druidpagestart1));
    gnome_druid_set_page (GNOME_DRUID (druid1), 
			  GNOME_DRUID_PAGE (druidpagestart1));

    gnome_druid_page_start_set_bg_color(
	GNOME_DRUID_PAGE_START (druidpagestart1),
	&druidpagestart1_bg_color);
    gnome_druid_page_start_set_textbox_color(
	GNOME_DRUID_PAGE_START (druidpagestart1),
	&druidpagestart1_textbox_color);
    gnome_druid_page_start_set_logo_bg_color(
	GNOME_DRUID_PAGE_START (druidpagestart1),
	&druidpagestart1_logo_bg_color);
    gnome_druid_page_start_set_title_color(
	GNOME_DRUID_PAGE_START (druidpagestart1), 
	&druidpagestart1_title_color);


    if (!title.empty())
	gnome_druid_page_start_set_title(
	    GNOME_DRUID_PAGE_START (druidpagestart1),
	    _(title.c_str()));

    if (text)
	gnome_druid_page_start_set_text(
	    GNOME_DRUID_PAGE_START (druidpagestart1), 
	    _(text));

    if (!logo.empty())
	gnome_druid_page_start_set_logo(
	    GNOME_DRUID_PAGE_START (druidpagestart1),
	    gdk_imlib_load_image( (char*)(logo.c_str()) ) );

    gtk_signal_connect (GTK_OBJECT (druidpagestart1), "prepare",
			GTK_SIGNAL_FUNC (on_druidpage_prepare),
			this);

    gtk_signal_connect (GTK_OBJECT (druidpagestart1), "next",
			GTK_SIGNAL_FUNC (on_druidpage_next),
			this);

    gtk_signal_connect (GTK_OBJECT (druidpagestart1), "cancel",
			GTK_SIGNAL_FUNC (on_druidpage_cancel),
			this);

}

Gtk::VBox* Druid::createStandardPage(int page_id)
{
    GtkWidget *druidpagestandard1;
    GtkWidget *druid_vbox1;
    DruidVBox *dvb;

    druidpagestandard1 = gnome_druid_page_standard_new_with_vals ("", NULL);

    page_map[GNOME_DRUID_PAGE(druidpagestandard1)]=page_id;

    gtk_widget_ref (druidpagestandard1);
    gtk_object_set_data_full (GTK_OBJECT (window1), 
			      "druidpagestandard1", druidpagestandard1,
			      (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show_all (druidpagestandard1);
    gnome_druid_append_page (GNOME_DRUID (druid1), 
			     GNOME_DRUID_PAGE (druidpagestandard1));

    gnome_druid_page_standard_set_bg_color(
	GNOME_DRUID_PAGE_STANDARD (druidpagestandard1),
	&druidpagestandard1_bg_color);
    gnome_druid_page_standard_set_logo_bg_color(
	GNOME_DRUID_PAGE_STANDARD (druidpagestandard1),
	&druidpagestandard1_logo_bg_color);
    gnome_druid_page_standard_set_title_color(
	GNOME_DRUID_PAGE_STANDARD (druidpagestandard1),
	&druidpagestandard1_title_color);
    
    if (!title.empty())
	gnome_druid_page_standard_set_title(
	    GNOME_DRUID_PAGE_STANDARD (druidpagestandard1),
	    _(title.c_str()));
    
    if (!logo.empty() )
	gnome_druid_page_standard_set_logo(
	    GNOME_DRUID_PAGE_STANDARD (druidpagestandard1),
	    gdk_imlib_load_image ( (char*)(logo.c_str())));

    gtk_signal_connect (GTK_OBJECT (druidpagestandard1), "prepare",
			GTK_SIGNAL_FUNC (on_druidpage_prepare),
			this);

    gtk_signal_connect (GTK_OBJECT (druidpagestandard1), "next",
			GTK_SIGNAL_FUNC (on_druidpage_next),
			this);

    gtk_signal_connect (GTK_OBJECT (druidpagestandard1), "back",
			GTK_SIGNAL_FUNC (on_druidpage_back),
			this);

    gtk_signal_connect (GTK_OBJECT (druidpagestandard1), "cancel",
			GTK_SIGNAL_FUNC (on_druidpage_cancel),
			this);

    
    druid_vbox1 = GNOME_DRUID_PAGE_STANDARD (druidpagestandard1)->vbox;
    gtk_widget_ref (druid_vbox1);
    gtk_object_set_data_full (GTK_OBJECT (window1), "druid_vbox1", druid_vbox1,
			      (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (druid_vbox1);

    dvb=manage(new DruidVBox( (GtkVBox*)(druid_vbox1) ) );
    return((Gtk::VBox*)dvb);
}



void Druid::createFinishPage(int page_id,const char* text)
{
    GtkWidget *druidpagefinish1;

    druidpagefinish1 = gnome_druid_page_finish_new ();

    page_map[GNOME_DRUID_PAGE(druidpagefinish1)]=page_id;

    gtk_widget_ref (druidpagefinish1);
    gtk_object_set_data_full
	(GTK_OBJECT (window1),
	 "druidpagefinish1", druidpagefinish1,
	 (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (druidpagefinish1);
    gnome_druid_append_page(
	GNOME_DRUID (druid1),
	GNOME_DRUID_PAGE (druidpagefinish1));
    gnome_druid_page_finish_set_bg_color (
	GNOME_DRUID_PAGE_FINISH (druidpagefinish1), 
	&druidpagefinish1_bg_color);
    gnome_druid_page_finish_set_textbox_color (
	GNOME_DRUID_PAGE_FINISH (druidpagefinish1), 
	&druidpagefinish1_textbox_color);
    gnome_druid_page_finish_set_logo_bg_color (
	GNOME_DRUID_PAGE_FINISH (druidpagefinish1), 
	&druidpagefinish1_logo_bg_color);
    gnome_druid_page_finish_set_title_color (
	GNOME_DRUID_PAGE_FINISH (druidpagefinish1), 
	&druidpagefinish1_title_color);

    if (!title.empty())
	gnome_druid_page_finish_set_title(
	    GNOME_DRUID_PAGE_FINISH (druidpagefinish1),
	    _(title.c_str()));

    if (!logo.empty())
	gnome_druid_page_finish_set_logo(
	    GNOME_DRUID_PAGE_FINISH (druidpagefinish1),
	    gdk_imlib_load_image( (char*)(logo.c_str())));


    if (text)
	gnome_druid_page_finish_set_text(
	    GNOME_DRUID_PAGE_FINISH (druidpagefinish1), 
	    _(text));

    gtk_signal_connect (GTK_OBJECT (druidpagefinish1), "prepare",
			GTK_SIGNAL_FUNC (on_druidpage_prepare),
			this);

    gtk_signal_connect (GTK_OBJECT (druidpagefinish1), "finish",
			GTK_SIGNAL_FUNC (on_druidpage_finish),
			this);

    gtk_signal_connect (GTK_OBJECT (druidpagefinish1), "back",
			GTK_SIGNAL_FUNC (on_druidpage_back),
			this);

    gtk_signal_connect (GTK_OBJECT (druidpagefinish1), "cancel",
			GTK_SIGNAL_FUNC (on_druidpage_cancel),
			this);

}

void  Druid::set_buttons_sensitive(bool back,bool next,bool cancel)
{
    gnome_druid_set_buttons_sensitive(GNOME_DRUID (druid1), back,next,cancel);
}


int      Druid::getPageID(GnomeDruidPage* pid)
{
    return page_map[pid];
}

void Druid::on_prepare(GnomeDruidPage  *gnomedruidpage)
{
    cerr << "Prepare: page=" << gnomedruidpage << endl;
}

gboolean Druid::on_next(GnomeDruidPage  *gnomedruidpage)
{
    cerr << "Next clicked, page=" << gnomedruidpage << endl;
    return false;
}

gboolean Druid::on_back(GnomeDruidPage  *gnomedruidpage)
{
    cerr << "Back clicked, page=" << gnomedruidpage << endl;
    return false;
}

gboolean Druid::on_cancel(GnomeDruidPage  *gnomedruidpage)
{
    cerr << "Cancel clicked, page=" << gnomedruidpage << endl;
    return false;
}

void Druid::on_finish(GnomeDruidPage  *gnomedruidpage)
{
    cerr << "Finish clicked, page=" << gnomedruidpage << endl;
}

void Druid::setPage(int page_id)
{
    map<GnomeDruidPage*,int>::iterator m;

    for (m=page_map.begin(); m!=page_map.end(); ++m) {
	if ((*m).second && (*m).second==page_id) {
	    gnome_druid_set_page( GNOME_DRUID (druid1), 
				  (GnomeDruidPage*)((*m).first) );
	    return;
	}
    }
}

