
#include <gnome.h>

#include "htmlviewer.hh"

HTMLViewer::HTMLViewer() : Gtk::Widget(  gtk_xmhtml_new() )
{
    gtk_signal_connect (GTK_OBJECT (gtkobj()), "activate",
			GTK_SIGNAL_FUNC (HTMLViewer::on_activate), NULL);
}

HTMLViewer::HTMLViewer(const char* html_code) : Gtk::Widget( gtk_xmhtml_new() )
{
    gtk_xmhtml_source( (GtkXmHTML*)gtkobj()  ,  (char*)html_code);

    gtk_signal_connect (GTK_OBJECT (gtkobj()), "activate",
			GTK_SIGNAL_FUNC (HTMLViewer::on_activate), NULL);
}

void HTMLViewer::on_activate (GtkXmHTML *html, void *arg)
{
    XmHTMLAnchorCallbackStruct *cbs;
    cbs=(XmHTMLAnchorCallbackStruct*)arg;
//    cerr << "on_activate:  cbs->href=" << cbs->href << endl;
    gnome_url_show( cbs->href );
}

void HTMLViewer::set_html_source(const char* html_code)
{
    gtk_xmhtml_source( (GtkXmHTML*)gtkobj()  ,  (char*)html_code);
}



