
#ifndef _ICONLIST_HH
#define _ICONLIST_HH


#include <gtk--.h>

#ifdef _
#undef _
#endif

#ifdef N_
#undef N_
#endif

#include <gnome.h>


class IconList : public Gtk::Widget {

    private:

    GnomeIconList *icnlist;



    public:

    IconList(guint icon_width = 80, bool is_editable = FALSE);


    void set_selection_mode(GtkSelectionMode mode);

    int append(const string& icon_filename,const string& text);
    int append_imlib(GdkImlibImage *im,const string &text);

    void insert(int pos,const string& icon_filename,const string& text);
    void insert_imlib(int pos,GdkImlibImage *im,const string &text);
    void remove(int pos);

    void clear();

    void set_icon_data(int pos,gpointer data);
    gpointer get_icon_data(int pos);
    int find_icon_from_data(gpointer data);

    void freeze();
    void thaw();

    void moveto(int pos,double yalign);

    GtkVisibility icon_is_visible(int pos);

    void set_row_spacing(int spacing);
    void set_col_spacing(int spacing);
    void set_text_spacing(int spacing);
    void set_icon_border(int spacing);
    void set_icon_width(int w);
    void set_separators(const string& sep);

    int get_icon_at(int x,int y);

    int get_items_per_line();

    void select_icon(int idx);

    void unselect_icon(int pos);

    int unselect_all(GdkEvent* event,gpointer keep);
};


#endif
