/* 

                          Firewall Builder

                 Copyright (C) 2000 Vadim Kurland

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: helpers.cc,v 1.23 2001/06/22 23:16:05 vkurland Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#include <gtk--.h>

#include <gtk--/packer.h> 

#include "helpers.hh"
#include "FWObjectDatabase.hh"

#include "MessageDialog.hh"

#include <ctype.h>
#include <stdlib.h>

#include "XMLTools.hh"
#include "IPAddress.hh"

/*
 *  call this function from main()
 *
void register_signals()
{

  gtk_signal_new("data_changed",
		 GTK_RUN_FIRST,
		 object_class->type,
		 GTK_SIGNAL_OFFSET( GtkCListClass , event ),
		 gtk_marshal_NONE__NONE,
		 GTK_TYPE_NONE, 0 );
}
*/


/*
GtkTargetEntry target_table[4] = {
  { "STRING",     0, PolicyList::TARGET_STRING },
  { "text/plain", 0, PolicyList::TARGET_STRING },
  { "text/uri-list", 0, PolicyList::TARGET_URL },
  { "application/x-rootwin-drop", 0, PolicyList::TARGET_ROOTWIN }
};
*/

GtkTargetEntry target_table[1] = {
  { "application/octet-stream", 0, TARGET_OBJ },
};

guint n_targets = sizeof(target_table) / sizeof(target_table[0]);


/*
 *  Prints widgets tree starting from the given widget downwards
 */

Gtk::Widget* print_widget_tree(gint offset,Gtk::Widget *wp)
{
  if (wp==NULL) return (NULL);

  cerr << string(offset,' ') 
       << wp 
       << " "
       << wp->get_name() 
       << " "
       << " gtkobj="
       << wp->gtkobj()
       << " state="
       << (int)(wp->get_state())
       << " style="
       << gtk_widget_get_style(GTK_WIDGET(wp->gtkobj()))
       << endl;

  if ( Gtk::MenuShell::isA( wp ) ) {
      Gtk::Menu_Helpers::MenuList itms=((Gtk::MenuShell*)wp)->items();
      Gtk::Menu_Helpers::MenuList::iterator m;
      for (m=itms.begin(); m!=itms.end(); ++m) {
	  print_widget_tree( offset+2, (*m) );
      }
      return(NULL);
  }

  if ( Gtk::MenuItem::isA( wp ) ) {
      print_widget_tree( offset+2, ((Gtk::Bin*)wp)->get_child() );
      Gtk::Menu *sm=((Gtk::MenuItem*)wp)->get_submenu();
      if (sm)
	  print_widget_tree( offset+2, sm );
      return(NULL);
  }


  if ( Gtk::Bin::isA( wp ) ) {
    print_widget_tree( offset+2, ((Gtk::Bin*)wp)->get_child() );
    return(NULL);
  }

  if ( Gtk::Box::isA( wp ) ) {
    Gtk::Box      *bptr=(Gtk::Box*)wp;
    Gtk::Box_Helpers::BoxList   bl= bptr->children();
    Gtk::Box_Helpers::BoxList::iterator bl_i;
    Gtk::Box_Helpers::Child    *ch;
    
    for (bl_i=bl.begin(); bl_i!=bl.end(); bl_i++) {
      ch= *bl_i;
      print_widget_tree( offset+2 , ch->get_widget());
    }
    return(NULL);
  }

  if ( Gtk::Packer::isA(wp) ) {
    Gtk::Packer      *bptr=(Gtk::Packer*)wp;
    Gtk::Packer_Helpers::PackerList   bl= bptr->children();
    Gtk::Packer_Helpers::PackerList::iterator bl_i;
    Gtk::Packer_Helpers::Child    *ch;
    
    for (bl_i=bl.begin(); bl_i!=bl.end(); bl_i++) {
      ch= *bl_i;
      print_widget_tree( offset+2 , ch->get_widget());
    }
    return(NULL);
  }

  if ( Gtk::Notebook::isA(wp) ) {
    for (int i=0; i<10; ++i)
      print_widget_tree( offset+2,((Gtk::Notebook*)wp)->get_nth_page(i) );
    return(NULL);
  }

  if ( Gtk::Paned::isA(wp) ) {
    print_widget_tree( offset+2,
		       ((Gtk::Paned*)wp)->get_child1());
    print_widget_tree( offset+2,
		       ((Gtk::Paned*)wp)->get_child2());
    return(NULL);
  }

  if ( Gtk::Table::isA( wp ) ) {
    Gtk::Table_Helpers::TableList tbl=((Gtk::Table*)wp)->children();
    Gtk::Table_Helpers::TableList::iterator m;
    for (m=tbl.begin(); m!=tbl.end(); ++m) {
      print_widget_tree( offset+2,(*m));
    }
    return(NULL);
  }

  return(NULL);
}








static Gtk::Widget* find_widget_helper(gchar *wname,Gtk::Widget *wp)
{
  Gtk::Widget *nwp;
 
  //  cout << "find_widget: wp=" << wp << 
  //    "  wp->get_name()=" << wp->get_name() << 
  //    "  wname=" << wname << " \n";


  if (wp==NULL) return (NULL);

  if (wp->get_name() == wname)  return wp;

  if ( Gtk::MenuShell::isA( wp ) ) {
      Gtk::Menu_Helpers::MenuList itms=((Gtk::MenuShell*)wp)->items();
      Gtk::Menu_Helpers::MenuList::iterator m;
      for (m=itms.begin(); m!=itms.end(); ++m) {
	  nwp=find_widget_helper( wname , (*m) );
	  if (nwp) return(nwp);
      }
      return(NULL);
  }

  if ( Gtk::MenuItem::isA( wp ) ) {
      nwp=find_widget_helper( wname , ((Gtk::Bin*)wp)->get_child() );
      if (nwp) return(nwp);
      Gtk::Menu *sm=((Gtk::MenuItem*)wp)->get_submenu();
      if (sm)
	  nwp=find_widget_helper( wname , sm );
      return(nwp);
  }



  if ( Gtk::Bin::isA( wp ) ) {
    nwp=find_widget_helper( wname , ((Gtk::Bin*)wp)->get_child() );
    return(nwp);
  }
  if ( Gtk::Box::isA( wp ) ) {
    Gtk::Box      *bptr=(Gtk::Box*)wp;
    Gtk::Box_Helpers::BoxList   bl= bptr->children();
    Gtk::Box_Helpers::BoxList::iterator bl_i;
    Gtk::Box_Helpers::Child    *ch;
    
    for (bl_i=bl.begin(); bl_i!=bl.end(); bl_i++) {
      ch= *bl_i;
      if ((nwp=find_widget_helper(wname,ch->get_widget()))!=0) 
	return(nwp);
    }
  }
  if ( Gtk::Packer::isA(wp) ) {
    Gtk::Packer      *bptr=(Gtk::Packer*)wp;
    Gtk::Packer_Helpers::PackerList   bl= bptr->children();
    Gtk::Packer_Helpers::PackerList::iterator bl_i;
    Gtk::Packer_Helpers::Child    *ch;
    
    for (bl_i=bl.begin(); bl_i!=bl.end(); bl_i++) {
      ch= *bl_i;
      if ((nwp=find_widget_helper(wname,ch->get_widget()))!=0) 
	return(nwp);
    }
  }
  if ( Gtk::Notebook::isA(wp) ) {
    for (int i=0; i<10; ++i)
      if ((
	   nwp=find_widget_helper( wname,
				  ((Gtk::Notebook*)wp)->get_nth_page(i) )
	   )!=0)  return(nwp);
    return(NULL);
  }

  if ( Gtk::Paned::isA(wp) ) {
    if ((nwp=find_widget_helper(wname,
			((Gtk::Paned*)wp)->get_child1()))!=0) return(nwp);
    if ((nwp=find_widget_helper(wname,
			((Gtk::Paned*)wp)->get_child2()))!=0) return(nwp);
  }
  return(NULL);
}





Gtk::Widget* find_widget(gchar *wname,Gtk::Widget *awp)
{
  Gtk::Widget *wp=awp;

  wp=awp->get_toplevel();
  return ( find_widget_helper(wname,wp) );
}

/*****************************************************************/

static Gtk::Widget* find_gtk_widget_helper(GtkWidget *gtkobj,Gtk::Widget *wp)
{
  Gtk::Widget *nwp;
 
  //  cout << "find_widget: wp=" << wp << 
  //          "  wp->gtkobj()=" << wp->gtkobj() << 
  //          "  gtkobj=" << gtkobj << endl;


  if (wp==NULL) return (NULL);

  if (wp->gtkobj() == gtkobj)  return wp;

  if ( GTK_IS_BIN( wp->gtkobj() ) ) {
    nwp=find_gtk_widget_helper( gtkobj , ((Gtk::Bin*)wp)->get_child() );
    return(nwp);
  }
  if ( GTK_IS_BOX( wp->gtkobj() ) ) {
    Gtk::Box      *bptr=(Gtk::Box*)wp;
    Gtk::Box_Helpers::BoxList   bl= bptr->children();
    Gtk::Box_Helpers::BoxList::iterator bl_i;
    Gtk::Box_Helpers::Child    *ch;
    
    for (bl_i=bl.begin(); bl_i!=bl.end(); bl_i++) {
      ch= *bl_i;
      nwp=find_gtk_widget_helper( gtkobj ,  ch->get_widget() );
      if (nwp!=NULL) return(nwp);
    }
  }
  return(NULL);
}





Gtk::Widget* find_gtk_widget(GtkWidget *gtkobj,Gtk::Widget *awp)
{
  Gtk::Widget *wp=awp;

  wp=awp->get_toplevel();
  return ( find_gtk_widget_helper(gtkobj,wp) );
}

void  setButtonLblAlignment(Gtk::Button *btn, gfloat x, gfloat y)
{
    ((Gtk::Label*)(btn->get_child()))->set_alignment(x,y);
}

Gtk::Menu* createOptionsMenu( vector<string> &items , 
			      string &active_item,
			      SigC::Slot0<void> callback)
{
    Gtk::Menu     *_m(manage(new Gtk::Menu()));
    Gtk::MenuItem *_mi;
    int             n, ind;
    vector<string>::iterator i;

    for (n=0,i=items.begin(); i!=items.end(); ++i,++n) {
	_mi = manage(new Gtk::MenuItem( (*i) ));
	_m->append(*_mi);
	_mi->show();
	_mi->set_user_data((gpointer) &(*i) );
//	if (callback!=NULL) _mi->activate_item.connect(callback);

	if ((*i)==active_item) ind=n;
    }
    _m->set_active( ind );

    if (callback!=NULL) _m->selection_done.connect(callback);

    return _m;
}

/**
 *    this function checks object name syntax validity
 */
bool  checkObjectName(const string& name)
{
    const char *cptr;

    cptr=name.c_str();

    if (name!="" && ! isdigit(*cptr)) {   // can't start with digit

	while ( *cptr=='_' ||
		*cptr=='.' ||
		*cptr=='-' ||
		*cptr==':' ||
		isalnum(*cptr) ) cptr++;

	if (*cptr==0) return(true);
    }

    MessageDialog::Error(
"Object name must consist only of
alphanumeric characters, should not 
start with a number or contain spaces");

    return(false);
}

/**
 *    this function checks correctness of IP address 
 */
bool checkIPaddress(const string& s)
{
    IPAddress a;
    try
    {
        a=s;
        return true;
    } catch(FWException &ex)
    {
	MessageDialog::Error(ex.toString());
        return false;
    }
}

/**
 *    this function checks correctness of a netmask
 */
bool checkNetmask(const string& s)
{
    Netmask a;
    try
    {
        a=s;
        return true;
    } catch(FWException &ex)
    {
	MessageDialog::Error(ex.toString());
        return false;
    }
}


FWObject* _findObjectByName(string &tree_id, const string &name)
{
    FWObject *tree=
	FWObjectDatabase::db->getById(FWObjectDatabase::db->std.ServicesId );
    return _findObjectByName(tree , name );
}


FWObject* _findObjectByName(FWObject *tree, const string &name)
{
    if(!tree)
        return NULL;

    if(name==tree->getName())
        return tree;
    
    vector<FWObject*>::iterator j;
    for(j=tree->begin(); j!=tree->end(); ++j)     
    {
        FWObject *o;
        if((o=(*j))!=NULL)   
        {
            string oname=o->getName();
            if(name==oname) 
                return o;
            
	    o=_findObjectByName(o, name);
	    if(o) 
                return o;
            
        }
    }
    return NULL; // not found
}


