/* 

                          Firewall Builder

                 Copyright (C) 2000 Vadim Kurland

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: helpers.hh,v 1.15 2001/06/22 18:22:56 lord Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/



#ifndef _HELPERS_HH
#  define _HELPERS_HH

#include <list>
#include <string>

#include <gtk/gtkselection.h>
#include <gtk--/widget.h>
#include <gtk--/dialog.h>
#include <gtk--/pixmap.h>

#include "FWObject.hh"
#include "FWObjectClipboard.hh"
#include "Preferences.hh"
#include "Resources.hh"

class main_window;

extern main_window *main_w;


Gtk::Widget* find_widget(gchar *wname,Gtk::Widget *wp);
Gtk::Widget* find_gtk_widget(GtkWidget *gtkobj,Gtk::Widget *awp);
Gtk::Widget* print_widget_tree(gint offset,Gtk::Widget *wp);

void  dialog_set_changed_callback(Gtk::Dialog *callback_object);

void  setButtonLblAlignment(Gtk::Button *btn, gfloat x, gfloat y);

bool   checkObjectName(const string& name);
bool   checkIPaddress(const string& ipAddress);
bool   checkNetmask(const string& ipAddress);

FWObject* _findObjectByName(string &tree_id, const string &name);
FWObject* _findObjectByName(FWObject *tree , const string &name);


Gtk::Menu *createOptionsMenu( vector<string> &items , 
			      string &active_item,
			      SigC::Slot0<void> on_changed_callback );



enum  {
  TARGET_STRING,
  TARGET_OBJ,
  TARGET_ROOTWIN,
  TARGET_URL
};

extern GtkTargetEntry target_table[];
extern guint n_targets;

#endif

