/* 

                          Firewall Builder

                 Copyright (C) 2000 Vadim Kurland

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: main_window.hh,v 1.18 2001/07/07 07:19:16 vkurland Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef _MAIN_WINDOW_HH
#define _MAIN_WINDOW_HH

#include <gtk--.h>

#include "helpers.hh"
#include "BuiltinDialog.hh"
#include "ObjectTree.hh"

// #include "gnome-wrappers/app.hh"

class PolicyList;

class main_window : public Gtk::Window
{   
    Gtk::Style  *window_style;

    friend void destroy_handler();

    gint on_delete_event(GdkEventAny* ev);

    void on_new1_activate();
    void on_open1_activate();
    void on_save1_activate();
    void on_saveas1_activate();
    void on_exit1_activate();
    void on_print_activate();

    void on_edit1_activate();
    
    void on_options_activate();
    void on_about1_activate();
    void on_release_notes_activate();
    void on_feedback_activate();

    void on_policy_line_add();
    void on_policy_line_remove();

    void on_insert_top();
    void on_append_bottom();
    void on_add_rule();
    void on_remove_rule();
    void on_move_up();
    void on_move_down();

    void on_tools_scan();

    void on_build_autorules();

    void on_compile();
    void on_install();
   
    string              active_tree_item;

    Gtk::MenuBar       *main_menubar1;
    Gtk::HPaned        *hpaned;
    Gtk::Statusbar     *main_statusbar;

    BuiltinDialog      *current_right_pane_dialog;
    Gtk::MenuItem      *custom_item;
    ObjectTree         *ctree1;
    bool                policy_in_right_pane;

    Gtk::Widget        *left_pane_port;
    Gtk::Widget        *right_pane_port;

    //  data for delayed OpenObject method
    string              oo_obj;

    Gtk::AccelGroup    *agr;


    // helper functions

    gint open_object_when_idle();

    void build_menu();
    PolicyList* extractPolicyList();

public:

    main_window();

    bool safe_to_close_right_pane();

    void LoadObjDB(const string& data_file);

    void schedule_open_object(string id);

    string    nowShowingObjectId();
    FWObject* nowShowingObject();
    bool      OpenObject (string id);
    void      ClearRightPane(bool logo);
    void      RefreshRightPane();

    void      showStatusbarMsg(const string& msg);
    void      clearStatusbar();

    BuiltinDialog* getRightPaneDialog() { return current_right_pane_dialog; }
    Gtk::MenuBar*  getMainMenuBar()     { return main_menubar1; }

    bool      checkAndSaveData();
};


#endif

